<template>
  <!-- <div class="header_nox">
    <el-button type="warning" circle @click="exportWord">下载</el-button>
    <el-button type="primary" circle v-show="!editable" @click="editable = !editable">编辑</el-button>
    <el-button type="primary" v-show=editable @click="saveData">确定</el-button>
  </div> -->
  <div id="printContent" ref="imageWrapper">
    <h3>502#底盖注胶工序生产质量记录5</h3>
    <div class="title_form">
      <div class="title_form_input">
        <span>生产线：</span>
        <span>{{ headData.head.shengcx }}</span>
      </div>
      <div class="title_form_input">
        <span>产品：</span>
        <span>{{ headData.head.chanpin }}</span>
      </div>
      <div class="title_form_input">
        <span>日期：</span>
        <span>{{ headData.head.reportTime1 }}</span>
      </div>
      <div class="title_form_input">
        <span>班次：</span>
        <span>{{ headData.head.banci }}</span>
      </div>
      <div class="title_form_input">
        <span>记录员：</span>
        <span>{{ headData.head.jiluyuan }}</span>
      </div>
      <div class="title_form_input">
        <span>接班时间：</span>
        <span>{{ headData.head.jieban1 }}</span>
      </div>
      <div class="title_form_input">
        <span>交班时间：</span>
        <span>{{ headData.head.jiaoban1 }}</span>
      </div>
    </div>
    <el-divider />

    <HJTABLE
      :SClist="zj5_mfjHeaderData"
      :tableHeader="zj5_mfjHeader"
      :labelName="labelName.b1"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="zj5_spHeaderData"
      :tableHeader="zj5_spHeader"
      :labelName="labelName.b2"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="zj5_baseHeaderData"
      :tableHeader="zj5_baseHeader"
      :labelName="labelName.b3"
      :editable="editable"
    ></HJTABLE>
    <HJTABLE
      :SClist="zj5_wgHeaderData"
      :tableHeader="zj5_wgHeader"
      :labelName="labelName.b4"
      :editable="editable"
    ></HJTABLE>
  </div>
</template>

<script>
const item = {
  name: "",
  birth: "",
  province: "",
  city: "",
  address: "",
  phone: "",
};
const header = {
  prop: "key",
  label: "自定义",
  editable: false,
  type: "input",
};
import { ref, reactive, onMounted } from "vue";
import { ElMessage } from "element-plus";
import { chong05VoLast, chong05VoSave } from "@/api/gaixian";
import html2canvas from "html2canvas";
import docxtemplater from "docxtemplater";
import PizZip from "pizzip";
import JSZipUtils from "jszip-utils";
import { saveAs } from "file-saver";
import HJTABLE from "@/components/arj/arj-table";
import { useRouter } from "vue-router";
import { headReport } from "@/api/head";
export default {
  name: "",
  components: { HJTABLE },
  props: {},
  setup(props) {
    const router = useRouter();
    const zj5_baseHeader = reactive([
      { prop: "shijian33", label: "时间", editable: "false", type: "text" },
      { prop: "no1", label: "1#模", editable: "false", type: "text" },
      { prop: "no2", label: "2#模", editable: "false", type: "text" },
      { prop: "no3", label: "3#模", editable: "false", type: "text" },
      { prop: "no4", label: "4#模", editable: "false", type: "text" },
      { prop: "hxw", label: "烘箱温", editable: "false", type: "text" },
      { prop: "ycw", label: "异常温", editable: "false", type: "text" },
      { prop: "tzcs", label: "调整措施", editable: "false", type: "text" },
      { prop: "tzr", label: "调整人签字", editable: "false", type: "text" },
    ]);
    const zj5_mfjHeader = reactive([
      { prop: "mfjcj", label: "密封胶厂家", editable: "false", type: "text" },
      {
        prop: "mfjxh_ph",
        label: "密封胶型号/批号",
        editable: "false",
        type: "text",
      },
      { prop: "yjl", label: "用胶量", editable: "false", type: "text" },
      { prop: "fp", label: "废品", editable: "false", type: "text" },
    ]);
    const zj5_spHeader = reactive([
      { prop: "shijian11", label: "时间", editable: "false", type: "text" },
      { prop: "sudu", label: "速度", editable: "false", type: "text" },
      { prop: "yali", label: "压力", editable: "false", type: "text" },
    ]);
    const zj5_wgHeader = reactive([
      { prop: "shijian22", label: "时间", editable: "false", type: "text" },
      { prop: "wgjc", label: "外观检测", editable: "false", type: "text" },
      { prop: "qxyy", label: "缺陷原因", editable: "false", type: "text" },
      { prop: "cstz", label: "措施调整", editable: "false", type: "text" },
    ]);

    let tableData = reactive([]);
    const formInline = reactive({
      user: "",
      region: "",
    });
    const imageWrapper = ref(null);

    let headData = reactive({
      head: {},
    });

    let labelName = {
      b1: "密封胶使用记录",
      b2: "注胶机速度记录",
      b3: "产品质量记录",
      b4: "外观质量检验",
    };
    let editable = ref(false);

    let SClist = ref([]);
    let hjData = ref({});

    let zj5_baseHeaderData = ref([]);
    let zj5_mfjHeaderData = ref([]);
    let zj5_mfjHeaderDataMap = ref({});
    let zj5_spHeaderData = ref([]);
    let zj5_wgHeaderData = ref([]);

    const submitForm = () => {};

    const handleEdit = (row) => {
      row.editable = true;
    };
    const handleDelete = (index) => {
      this.tableData.splice(index, 1);
    };
    const prepend = (index) => {
      item.editable = true;
      this.tableData.splice(index, 0, item);
    };
    const append = (index) => {
      item.editable = true;
      this.tableData.splice(index + 1, 0, item);
    };
    const deleteCurrentColumn = (index) => {
      this.tableHeader.splice(index, 1);
    };
    const insertBefore = (index) => {
      header.editable = true;
      this.tableHeader.splice(index, 0, header);
    };

    const getListData = async () => {
      const data = await chong05VoLast();
      console.log(".........", data);
      parse(data);
    };
    function parse(data) {
      headData.head = data.data.head;
      headData.head.reportTime1 = headData.head.reportTime.substr(0, 10);
      // headData.head.jieban1 = headData.head.jieban.substr(11, 5);
      // headData.head.jiaoban1 = headData.head.jiaoban.substr(11, 5);
      zj5_baseHeaderData.value = data.data.zj5BaseList;
      (zj5_mfjHeaderData.value = [
        data.data.zj5Mfj == null ? "" : data.data.zj5Mfj,
      ]),
        (zj5_mfjHeaderDataMap =
          data.data.zj5Mfj == null ? "" : data.data.zj5Mfj),
        (zj5_spHeaderData.value = data.data.zj5SpList),
        (zj5_wgHeaderData.value = data.data.zj5WgList),
        zj5_spHeaderData.value.filter((item) => {
          if (item.shijian != null) item.shijian11 = item.shijian.substr(11, 5);

          return item;
        });
      zj5_wgHeaderData.value.filter((item) => {
        if (item.shijian != null) item.shijian22 = item.shijian.substr(11, 5);

        return item;
      });
      zj5_baseHeaderData.value.filter((item) => {
        if (item.shijian != null) item.shijian33 = item.shijian.substr(11, 5);

        return item;
      });
      hjData.value = {
        ...headData.head,
        ...zj5_mfjHeaderDataMap,
      };
    }
    const saveData = async () => {
      editable = false;
      let data = {
        head: headData.head,
        zj5BaseList: zj5_baseHeaderData.value,
        zj5Mfj: zj5_mfjHeaderData.value[0],
        zj5SpList: zj5_spHeaderData.value,
        zj5WgList: zj5_wgHeaderData.value,
      };
      console.log("save data...", data);
      const dt = await chong05VoSave(data);
      if (dt.code == 0) {
        ElMessage({
          message: "修改成功",
          type: "success",
        });
      }
      console.log(dt);
    };
    //截图
    const toImage = () => {
      html2canvas(imageWrapper.value, {
        logging: false,
        allowTaint: true,
        scale: window.devicePixelRatio,
        // width: shareContent.clientWidth, //dom 原始宽度
        // height: shareContent.clientHeight,
        scrollY: 0,
        scrollX: 0,
        useCORS: true,
        backgroundColor: "#ffffff",
      }).then(function (canvas) {
        // console.log(canvas);
        let imgUrl = canvas.toDataURL("image/png");
        var tempLink = document.createElement("a"); // 创建一个a标签
        tempLink.style.display = "none";
        tempLink.href = imgUrl;
        tempLink.setAttribute("download", "底盖注胶工序生产质量记录"); // 给a标签添加下载属性
        if (typeof tempLink.download === "undefined") {
          tempLink.setAttribute("target", "_blank");
        }
        document.body.appendChild(tempLink); // 将a标签添加到body当中
        tempLink.click(); // 启动下载
        document.body.removeChild(tempLink); // 下载完毕删除a标签
        window.URL.revokeObjectURL(imgUrl);
      });
    };
    // 点击导出word
    function exportWord() {
      // 读取并获得模板文件的二进制内容
      JSZipUtils.getBinaryContent("g05.docx", function (error, content) {
        // input.docx是模板。我们在导出的时候，会根据此模板来导出对应的数据
        // 抛出异常
        if (error) {
          throw error;
        }

        // 创建一个JSZip实例，内容为模板的内容
        let zip = new PizZip(content);
        // 创建并加载docxtemplater实例对象

        let doc = new docxtemplater().loadZip(zip).setOptions({
          nullGetter: function () {
            return "";
          },
        });
        // 设置模板变量的值
        doc.setData({
          ...hjData.value,
          t1: zj5_spHeaderData.value,
          t2: zj5_baseHeaderData.value,
          t3: zj5_wgHeaderData.value,
        });

        try {
          // 用模板变量的值替换所有模板变量
          doc.render();
        } catch (error) {
          // 抛出异常
          let e = {
            message: error.message,
            name: error.name,
            stack: error.stack,
            properties: error.properties,
          };
          console.log(JSON.stringify({ error: e }));
          throw error;
        }

        // 生成一个代表docxtemplater对象的zip文件（不是一个真实的文件，而是在内存中的表示）
        let out = doc.getZip().generate({
          type: "blob",
          mimeType:
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
        });
        // 将目标文件对象保存为目标类型的文件，并命名
        saveAs(out, "底盖注胶工序生产质量记录.docx");
      });
    }
    const getRouterData = async (req) => {
      console.log("req....", req);
      const data = await headReport(req);
      console.log("jbj router data.....", data);

      parse(data);
    };
    onMounted(() => {
      console.log("rrrrrrrrrrr", router.currentRoute.value.query);
      let head_id = router.currentRoute.value.query.id;
      let leixing = router.currentRoute.value.query.leixing;
      console.log("vue recv....", head_id, leixing);
      if (head_id == null) {
        getListData();
      } else {
        getRouterData({ head_id: head_id, leixing: leixing });
      }
    });
    return {
      saveData,
      submitForm,
      formInline,
      tableData,
      insertBefore,
      deleteCurrentColumn,
      append,
      prepend,
      handleDelete,
      handleEdit,
      editable,
      getListData,
      headData,
      toImage,
      imageWrapper,
      labelName,
      exportWord,
      zj5_baseHeaderData,
      zj5_mfjHeaderData,
      zj5_spHeaderData,
      zj5_wgHeaderData,
      zj5_baseHeader,
      zj5_mfjHeader,
      zj5_spHeader,
      zj5_wgHeader,
      chong05VoLast,
      chong05VoSave,
      zj5_mfjHeaderDataMap,
    };
  },
};
</script>
<style lang="scss" scoped>
.header_nox {
  text-align: right;
}

#printContent h3 {
  text-align: center;
  margin-bottom: 40px;
  font-size: 26px;
  font-weight: bold;
}

.title_form {
  display: flex;
  justify-content: space-around;
  align-items: center;
  // margin-bottom: 20px;
}

.title_form_input {
  font-size: 16px;
}
</style>
